

<h1 align="center" > Ilse Langnar's Notebook </h1>
<h2 align="center" > Memoirs of a Recon Corps Member </h2>

<p align="center">
  <img src="https://github.com/ilse-langnar/notebook/blob/dev/markdown/ilse.jpeg" alt="Ilse"/>
</p>
<br/>


<h4 align="center" > Ilse Langnar's Notebook is a free, knowledge management platform. </h4>
<br/>


Imagine [Roam Research](https://roamresearch.com/) + [Obsidian](https://obsidian.md/) + [Anki](https://ankiweb.net/) + [Supermemo](https://www.supermemopedia.com/wiki/Main_Page) but without their downsides such as online-only, lock-in, bad algorithm, complexity etc.

Ilse aims to be the ultimate study and note-taking tool by learning from its predecessors and building something that last by implementing a standard instead of building just software which might [rot overtime]( https://en.wikipedia.org/wiki/Software_rot).

Try the online [Demo](https://ilse-langnar.github.io/notebook/demo/index.html) or download it form [Linux](https://github.com/ilse-langnar/notebook/releases/download/0.8/ilse-langnar-notebook-0.1.8.AppImage) [Windows](https://github.com/ilse-langnar/notebook/releases/download/0.8/ilse-langnar-notebook-0.1.8.AppImage) or [OS x]().

If anything goes wrong, please open a [Issue](https://github.com/ilse-langnar/notebook/issues/new).

## Why
To augment human cognition with memory, references and more.
Ilse is based on the Vitruvian Brain Framework: https://ilse-langnar.github.io/notebook/vitruvian-brain.html
We avoid any type of lock-in due to the fact that a simple set of files and folder is able to reproduce the entire system, which means that with a simple standardized format can be visualized in multiple ways like: __Mind Maps__, __Tree__, __Infinite Canvas__, __Spreadsheet__, and more.
And given that the format is standardized, if someone finds a new way of reprensenting data, we would simply have to write a plugin that representes those already standardized into the desired new format(presentation).
This way we avoid anye sort of proprietary binary format for organization and visualization, even if the software rots and dies, the files are still going to be there, the standard is still there, so you can, for example, implement a command line spreadsheet that can be visualized in a cloud client, a Web Browser, a Callphone, a toaster ... you get it.
This started with frustration not only with lock-in but the lack of extensability and standardazation of previous solutions.

## Improves on:
<img src="https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/improves-on.png"  />


## Screenshots
<img src="https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/ilse-screenshot-15.png" />
<img src="https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/ilse-screenshot-16.png" />
<img src="https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/ilse-screenshot-17.png" />
<img src="https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/ilse-screenshot-2.png" />
<img src="https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/ilse-screenshot-13.png" />
<img src="https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/ilse-screenshot-14.png" />

## Forgetting Curve
<img src="https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/forgetting-curve.jpg" />

## Incremental Reading & Spaced Repetition( How it works )
<img src="https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/incremental-reading.svg" style="width: 100% !important;" />

## Incremental Video( How it works )
<img src="https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/incremental-video.svg" style="width: 100% !important;" />

### Example 1 - Chemistry
You import a wikipedia article on: Alcohol, and you see a table with a bunch of alcohols and how to name them: 
<br>
<img src="https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/all-alcohols.png" style="width: 100% !important;" />
<br>

You can take one screenshot for each item, in order to add them to your "study" where each item will get scheduled individually based on your memory
<br>
<img src="https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/alcohol.png" style="width: 200px;" />
<img src="https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/alcohol-1.png" style="width: 200px;" />
<img src="https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/alcohol-2.png" style="width: 200px;" />
<img src="https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/alcohol-3.png" style="width: 200px;" />
<br>

## Statistics
<img src="https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/daily-info-statistics.png" style="width: 200px;" />

## One data, many visualizations
<img src="https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/spreadsheet-light-mode.png" style="width: 200px;" />
<img src="https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/spreadsheet-dark-mode.png" style="width: 200px; " />
<img src="https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/memex.png" style="width: 200px; " />

## Making items(Flashcards) out of a biology book
[![Watch the video](https://github.com/ilse-langnar/notebook/blob/dev/docs/ilse.jpeg)](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/first-brain.mp4)



## Plugins, Themes, Snippets 
If you want to make a plugin, please download the [Plugin Template](https://github.com/ilse-langnar/plugin-template) if you want to make a Theme, then download the [Theme Template](https://github.com/ilse-langnar/theme-template) and if you want to make a snippt, just make a normal note with the tag `#i/css` and a css code block like ```css body { background: red; }```

## Todos
Todo List
- Vitruvian
    - [ ] Make Vim plugin for Vitruvian
    - [ ] Make VSCode plugin for vitruvian
    - [ ] Make Emacs plugin for vitruvian
    - [ ] Make Sublime Text for vitruvian
    - [ ] Make command line client for vitruvian
- Ilse
    - [ ] Make official docker image
    - [ ] Make windows build work
    - [ ] Make Linux build work
    - [ ] Make OS X build work
    - [ ] Make android client
    - [ ] Make iOS client

## Installing
- [Installing](https://github.com/ilse-langnar/notebook/blob/dev/markdown/dev.md)
- [Contributing](https://github.com/ilse-langnar/notebook/blob/dev/markdown/contributing.md)
